using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace F35537
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private ChartStripLine MeanStrip = new ChartStripLine();
		private TopArrayModel model = new TopArrayModel();
		private System.Windows.Forms.Timer timer1;
		private int dataPointsCount;
		private int numPointsPerTimer = 10;
		private int yMax = 1000;
		private int yMin = -100;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb(((System.Byte)(55)), ((System.Byte)(245)), ((System.Byte)(245)), ((System.Byte)(220))), System.Drawing.Color.White);
			this.chartControl1.ColumnWidthMode = Syncfusion.Windows.Forms.Chart.ChartColumnWidthMode.DefaultWidthMode;
			this.chartControl1.Controls.Add(this.chartControl1.Legend);
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.chartControl1.Legend.Location = new System.Drawing.Point(594, 200);
			this.chartControl1.Legend.Name = "";
			this.chartControl1.Legend.Size = new System.Drawing.Size(76, 28);
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.PrimaryXAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControl1.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.PrimaryYAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControl1.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.Size = new System.Drawing.Size(680, 390);
			this.chartControl1.Spacing = 10F;
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.Tilt = 30F;
			// 
			// chartControl1.ToolBar
			// 
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(26, 26);
			this.chartControl1.ZoomFactorX = 1;
			this.chartControl1.ZoomFactorY = 1;
			this.chartControl1.ZoomOutIncrement = 1.5;
			// 
			// timer1
			// 
			this.timer1.Interval = 300;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(680, 390);
			this.Controls.Add(this.chartControl1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Stripline Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("Products");

			series.Text = series.Name;
			series.SeriesModelImpl = model;

			series.Type = ChartSeriesType.Spline;
			
			series.Style.Interior = new BrushInfo(GradientStyle.None, Color.Red, Color.Red);
			
			this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Auto ;
			this.chartControl1.Series.Add(series);

			this.timer1.Start();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			this.chartControl1.ChartAreaPaint+=new PaintEventHandler(chartControl1_ChartAreaPaint);
			Random r = new Random();
					
			for(int i =0; i < numPointsPerTimer; i++)
			{
				this.model.AddXY(dataPointsCount++,new double[]{r.Next(yMin, yMax)});
			}

			this.chartControl1.PrimaryXAxis.Range.Min =0;
			this.chartControl1.PrimaryXAxis.Range.Max =dataPointsCount;

			int visibleRange = 5 * this.numPointsPerTimer;
			
			if(dataPointsCount > visibleRange)
			{
				model.TopCount = visibleRange;
				this.chartControl1.PrimaryXAxis.Range.Max = dataPointsCount;
				this.chartControl1.PrimaryXAxis.Range.Min = dataPointsCount - visibleRange;
			}
			else
				model.TopCount = 0;
		}

		private void chartControl1_ChartAreaPaint(object sender, PaintEventArgs e)
		{
			double xPos = this.chartControl1.Series[0].Points [3].YValues[0];
			ChartPoint pt1 = new ChartPoint(chartControl1.PrimaryXAxis.VisibleRange.Min,xPos);
			ChartPoint pt2 = new ChartPoint( chartControl1.PrimaryXAxis.VisibleRange.Max,xPos);
			Point lineStart = chartControl1.ChartArea.GetPointByValue(pt1);
			PointF lineEnd = chartControl1.ChartArea.GetPointByValue(pt2);
			e.Graphics.DrawLine(new Pen(Color.Red,0.2f),lineStart, lineEnd);
		}
	}
}
